/* This is the AV Script */
/*  9/29/96 Latest version adds Mixing function */
/* 10/02/96 Improves mixing to space mixdown correctly */  
/* 10/05/96 Fixes the Audio/Video syncing */
/* 11/03/96 Added requester messages */
/*  2/13/96 Added Support for FlyerAddAudio 1.01 */
/*  6/30/96 Env Support and 4.2 Support */

call remlib('PROJECT_REXX_PORT')
call addlib('PROJECT_REXX_PORT',0)

OPEN(myfile,"env:addaudio.txt",'Write')     

rx startfilereq("Output File Name")
exit=1
do while exit=1
   filename1=queryfilereq()
   if filename1=0 then 
      call quit
    else NOOP
      if filename1~="" then exit=0
      else NOOP
      address command "c:wait 1"
      end

fpatht=filename1
patht=''
filenamet=''
lenfpt=length(fpatht)
if lenfpt>1 then do
   lastpt=lastpos('/',fpatht,lenfpt)
   if (lastpt~=0) then do
      if (lastpt~=lenfpt) then filenamet=right(fpatht,(lenfpt-lastpt))
      patht=left(fpatht,lastpt-1)
      end
   else if lastpt=0 then do
      lastpt=lastpos(':',fpatht,lenfpt)
      if (lastpt~=0) then do
         if (lastpt~=lenfpt) then filenamet=right(fpatht,(lenfpt-lastpt))
         patht=left(fpatht,lastpt)
         end
      end
   if patht~='' then do
      call pragma('D',patht)
      patht=pragma('D','RAM:')
      end

call req_close()

if (patht='') then do
   call req_tell('FlyerAddAudio cancelled','    You need to select a drive/folder','       from bottom of Flyer window')
   call quit()
   end

if (filenamet='') then do
   call req_tell('FlyerAddAudio cancelled','   You need to type in a filename')
   call quit()
   end

if (right(patht,1)~="/") & (right(patht,1)~=":") then
   patht=patht||"/"

filename1=patht||filenamet

mytest = 0

if exists(filename1) then do
   test=req_tell('That file already exists','  Select Continue to overwrite file')
   if test=0 then call quit()
   end

WRITELN(myfile,filename1||",");

count = croutonsinproject()

croutonpick(0)

if croutongettag(AudioOn) > 3 then
   count = 3 

if count > 2 then 
   do
   count = croutonsinproject()
   OPEN(tempfile,"env:mixer.txt","Write");
   WRITELN(tempfile,filename1||".mixer,");
   croutonpick(0)
   testy = croutongettag(AudioStart)/2
   if testy > 0 then
      testy = testy - 1
   if croutongettag(AudioOn) > 3 then 
      do
      OPEN(temp2,"env:flyaudio.txt",'Write');
      WRITELN(temp2,croutonname()||",");
      WRITELN(temp2,"1");     
      WRITELN(temp2,filename1||".Audio,0,"||croutongettag(RecFields)/2||",1");
      CLOSE(temp2);
      call req_open("Stripping Audio...Please Wait" , "Left-Amiga Delete to abort Operation")
      address command "Prowave:FlyerStripAudio >CON: env:flyaudio.txt" 
      call req_close()
      WRITELN(tempfile,count);
      WRITELN(tempfile,filename1||".audio,0,"||croutongettag(RecFields)/2||",0,"||croutongettag(AUDIOON)||","||croutongettag(AUDIOVOLUME1)||","||croutongettag(AUDIOVOLUME2)||",0,0,0,0");
      end
   if croutongettag(AudioOn) < 4 then 
      do
      WRITELN(tempfile,count-1);
      end
   next = 1
   do while next < count
      call croutonpick(next)
      WRITELN(tempfile,croutonname()||","||croutongettag(AudioStart)/2||","||croutongettag(AudioDuration)/2||","||testy + croutontime()/2||","||croutongettag(AUDIOON)||","||croutongettag(AUDIOVOLUME1)||","||croutongettag(AUDIOVOLUME2)||","||croutongettag(AudioPan1)||","||croutongettag(AudioPan2)||","||croutongettag(AudioAttack)||","||croutongettag(AudioDecay));
      next = next + 1
      end
   CLOSE(tempfile);
   call req_open("Mixing Audio... Please Wait", "Left-Amiga Delete to abort Operation")
   address command "prowave:promix >CON: env:mixer.txt"
   call req_close()
   croutonpick(0)
   if croutontype() = STIL then 
      do
      OPEN(testfile,"env:still.txt",'Write')     
      WRITELN(testfile,croutonname()||".newvid,");
      WRITELN(testfile,croutonname()||","||croutongettag(Duration)||","||Audval);
      CLOSE(testfile)
      call req_open("Converting Still...Please Wait" , "Left-Amiga Delete to abort Operation")       
      address command  "prowave:Still2Clip >CON: env:still.txt"  
      call req_close()
      WRITELN(myfile,croutonname()||".newvid,0");
      end
   else
      WRITELN(myfile,croutonname()||",0");

   WRITELN(myfile,filename1||".mixer,0");    
end

if count = 2 then do
   call croutonpick(1)
   stuff = croutontime()/2
   SAY stuff
   if croutontype() = CLIP then
      stuff = 0
   if stuff > 0 then
      stuff = stuff - 1
   call croutonpick(0)
   if croutontype() = STIL then 
      do
      OPEN(testfile,"env:still.txt",'Write')     
      WRITELN(testfile,croutonname()||".newvid,");
      WRITELN(testfile,croutonname()||","||croutongettag(Duration)||",1");
      CLOSE(testfile)
      call req_open("Converting Still... Please Wait", "Left-Amiga Delete to Abort Operation")
      address command  "prowave:Still2Clip >CON: env:still.txt"
      call req_close()  
      WRITELN(myfile,croutonname()||".newvid,0");
      end
   else
      WRITELN(myfile,croutonname()||","||stuff+croutongettag(ClipStartField)/2);
   stuff = croutongettag(ClipStartField)/2
   call croutonpick(1)
   WRITELN(myfile,croutonname()||","||croutongettag(AudioStart)/2);
end
            
CLOSE(myfile)

call req_open("Adding Audio... Please Wait", "Left-Amiga Delete to Abort Operation")

address command  "Prowave:FlyerAddAudio >CON: env:addaudio.txt" 

call req_close()  

call croutonpick(0)
if croutontype() = STIL then do
   address command "Delete "||croutonname()||".newvid.Prowave"
   address command "Delete "||croutonname()||".newvid"
   end 

address command "Delete "||croutonname()||".Prowave"
address command "Delete "||filename1||".mixer"
address command "Delete "||filename1||".audio" 

if ~exists(filename1||".I") then do
   count = MAKEICON(filename1,0)
