/* This is the Join Clips Script */
/* 9/29/96 */
/* 10/11/96 Fix Join Video Only CLips */
/* 10/12/96 Add Flyer Still Support */
/* 10/24/96 Make Audio Clips Not get Video Croutons */
/* 11/21/96 Fix Flyer Stills to correct Length */
/* 02/13/97 Fix for Join version 1.01  */
/* 03/01/97 Fix No Menu Being Displayed */
/* 03/25/97 Fix Select Join */
/* 05/05/97 Add Support for Updated Still2Clip */

call remlib('PROJECT_REXX_PORT')
call addlib('PROJECT_REXX_PORT',0)

if exists("ENV:OZ-PanicStop") then address command "delete ENV:OZ-PanicStop QUIET"

OPEN(myfile,"ram:Prowave.txt",'Write')     

rx startfilereq("Output File Name")
exit=1
do while exit=1
   filename1=queryfilereq()
   if filename1=0 then 
      call quit
    else NOOP
      if filename1~="" then exit=0
      else NOOP
      address command "c:wait 1"
      end

call req_error(' FlyerJoinClips running')

fpatht=filename1
patht=''
filenamet=''
lenfpt=length(fpatht)
if lenfpt>1 then do
   lastpt=lastpos('/',fpatht,lenfpt)
   if (lastpt~=0) then do
      if (lastpt~=lenfpt) then filenamet=right(fpatht,(lenfpt-lastpt))
      patht=left(fpatht,lastpt-1)
      end
   else if lastpt=0 then do
      lastpt=lastpos(':',fpatht,lenfpt)
      if (lastpt~=0) then do
         if (lastpt~=lenfpt) then filenamet=right(fpatht,(lenfpt-lastpt))
         patht=left(fpatht,lastpt)
         end
      end
   if patht~='' then do
      call pragma('D',patht)
      patht=pragma('D','RAM:')
      end
call req_close()

if (patht='') then do
   call req_tell('FlyerJoinClips cancelled','    You need to select a drive/folder','       from bottom of Flyer window')
   call quit()
   end

if (filenamet='') then do
   call req_tell('FlyerJoinClips cancelled','   You need to type in a filename')
   call quit()
   end

if (right(patht,1)~="/") & (right(patht,1)~=":") then
   patht=patht||"/"

filename1=patht||filenamet

if exists(filename1) then do
   test=req_tell('That file already exists','  Select Continue to overwrite file')
   if test=0 then call quit()
   address command 'delete 'filename1' QUIET'
   if exists(filename1||'.i') then address command 'delete 'filename1'.i QUIET'
   end

WRITELN(myfile,filename1||",");

count = croutonsinproject()

SAY count

testing = 0

next = 1
selected = 0
do while next < count+1
   row = trunc(next/8)
   col = next - (row*8)
   row = row + 1
   selected = selected + croutonselected(row,col)
   if croutonselected(row,col) = 1 then do
      mycount.testing = next-1
      testing = testing + 1
   end
   SAY row||" "||col||" "||selected
   next = next + 1
end

SAY count

/* --- Check previous audio clip --- */
Audval = 0
next = 0
do while next < count
   croutonpick(next)
   if croutontype() = CLIP then
      do
      if croutongettag(AudioOn) > 3 then
         Audval = 1
      end 
   next = next + 1
end

if selected < 2 then do
   WRITELN(myfile,count);
   next = 0
   do while next < count
      call croutonpick(next)
      if croutontype() = AUD then
         WRITELN(myfile,croutonname()||","||croutongettag(AudioStart)/2||","||croutongettag(AudioDuration)/2);
      else
         do
          if croutontype() = STIL then
             do
            OPEN(testfile,"ram:still.txt",'Write')     
            WRITELN(testfile,croutonname()||".newvid"||next||",");
            WRITELN(testfile,croutonname()||","||croutongettag(Duration)/2||","||Audval);
            CLOSE(testfile)
            Say next
            call req_open("Converting Still... Please Wait","Left-Amiga Delete to abort Operation")            
            address command  "prowave:Still2Clip >CON: ram:still.txt"  
            call req_close()
            address command "Delete "||croutonname()||".P"
            if exists("ENV:OZ-PanicStop") then 
               goto endit
            WRITELN(myfile,croutonname()||".newvid"||next||",0,"||croutongettag(Duration)/2);
            end
         else 
            WRITELN(myfile,croutonname()||","||croutongettag(ClipStartField)/2||","||croutongettag(Duration)/2);
       end
     next = next + 1              
   end
end

if selected > 1 then do
   WRITELN(myfile,selected);
   next = 0
   do while next < selected
      call croutonpick(mycount.next)
      if croutontype() = AUD then
         WRITELN(myfile,croutonname()||","||croutongettag(AudioStart)/2||","||croutongettag(AudioDuration)/2);
      else
         do
          if croutontype() = STIL then
             do
            OPEN(testfile,"ram:still.txt",'Write')     
            WRITELN(testfile,croutonname()||".newvid"||next||",");
            WRITELN(testfile,croutonname()||","||croutongettag(Duration)/2||","||Audval);
            CLOSE(testfile)
            Say next
            call req_open("Converting Still... Please Wait","Left-Amiga Delete to abort Operation")            
            address command  "prowave:Still2Clip >CON: ram:still.txt"  
            call req_close()
            address command "Delete "||croutonname()||".P"
            WRITELN(myfile,croutonname()||".newvid"||next||",0,"||croutongettag(Duration)/2);

            if exists("ENV:OZ-PanicStop") then 
               goto endit
                
                
            end
         else 
            WRITELN(myfile,croutonname()||","||croutongettag(ClipStartField)/2||","||croutongettag(Duration)/2);
       end
     next = next + 1              
   end
end
            
CLOSE(myfile)

call req_open("Joining Clips... Please Wait.", "Left-Amiga Delete to abort Operation")
address command  "prowave:FlyerJoinClips >CON: ram:prowave.txt"  
call req_close()


endit:

call croutonpick(0)
if croutontype() = STIL then
   address command "Delete "||croutonname()||".newvid0.Prowave"
   
address command "Delete "||croutonname()||".Prowave"

next = 0
do while next < count
   call croutonpick(next)
   if croutontype() = STIL then
      do
      address command "Delete "||croutonname()||".newvid"||next
      address command "Delete "||croutonname()||".Prowave"
      end
   next = next + 1
end 

call croutonpick(0)
if croutontype() ~= AUD then
   count = MAKEICON(filename1,0)
